com.io7m.r2.core

## Class R2LightBufferDescription

- java.lang.Object
- - com.io7m.r2.core.R2LightBufferDescription

- All Implemented Interfaces:
    R2LightBufferDescriptionType, R2RenderTargetDescriptionType

      @Generated(value={"Immutables.generator","R2LightBufferDescriptionType"})
      public final class R2LightBufferDescription
      extends Object
      implements R2LightBufferDescriptionType

  The type of light buffer descriptions.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `R2LightBufferDescription.Builder` Builds instances of type `R2LightBufferDescription`.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `com.io7m.jareas.core.AreaInclusiveUnsignedLType` | `area()`
    `static R2LightBufferDescription.Builder` | `builder()` Creates a builder for `R2LightBufferDescription`.
    `R2LightBufferComponents` | `components()`
    `static R2LightBufferDescription` | `copyOf(R2LightBufferDescriptionType instance)` Creates an immutable copy of a `R2LightBufferDescriptionType` value.
    `boolean` | `equals(Object another)` This instance is equal to all instances of `R2LightBufferDescription` that have equal attribute values.
    `int` | `hashCode()` Computes a hash code from attributes: `area`, `components`.
    `static R2LightBufferDescription` | `of(com.io7m.jareas.core.AreaInclusiveUnsignedLType area, R2LightBufferComponents components)` Construct a new immutable `R2LightBufferDescription` instance.
    `String` | `toString()` Prints the immutable value `R2LightBufferDescription` with attribute values.
    `R2LightBufferDescription` | `withArea(com.io7m.jareas.core.AreaInclusiveUnsignedLType value)` Copy the current immutable object by setting a value for the `area` attribute.
    `R2LightBufferDescription` | `withComponents(R2LightBufferComponents value)` Copy the current immutable object by setting a value for the `components` attribute.

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Method Detail

    - #### area

          public com.io7m.jareas.core.AreaInclusiveUnsignedLType area()

      Specified by:
        `area` in interface `R2LightBufferDescriptionType`
      Specified by:
        `area` in interface `R2RenderTargetDescriptionType`
      Returns:
        The value of the `area` attribute

    - #### components

          public R2LightBufferComponents components()

      Specified by:
        `components` in interface `R2LightBufferDescriptionType`
      Returns:
        The components that will be allocated in the light buffer

    - #### withArea

          public final R2LightBufferDescription withArea(com.io7m.jareas.core.AreaInclusiveUnsignedLType value)

      Copy the current immutable object by setting a value for the `area` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
      Parameters:
        `value` - A new value for area
      Returns:
        A modified copy of the `this` object

    - #### withComponents

          public final R2LightBufferDescription withComponents(R2LightBufferComponents value)

      Copy the current immutable object by setting a value for the `components` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
      Parameters:
        `value` - A new value for components
      Returns:
        A modified copy of the `this` object

    - #### equals

          public boolean equals(Object another)

      This instance is equal to all instances of `R2LightBufferDescription` that have equal attribute values.
      Overrides:
        `equals` in class `Object`
      Returns:
        `true` if `this` is equal to `another` instance

    - #### hashCode

          public int hashCode()

      Computes a hash code from attributes: `area`, `components`.
      Overrides:
        `hashCode` in class `Object`
      Returns:
        hashCode value

    - #### toString

          public String toString()

      Prints the immutable value `R2LightBufferDescription` with attribute values.
      Overrides:
        `toString` in class `Object`
      Returns:
        A string representation of the value

    - #### of

          public static R2LightBufferDescription of(com.io7m.jareas.core.AreaInclusiveUnsignedLType area,
                                                    R2LightBufferComponents components)

      Construct a new immutable `R2LightBufferDescription` instance.
      Parameters:
        `area` - The value for the `area` attribute
        `components` - The value for the `components` attribute
      Returns:
        An immutable R2LightBufferDescription instance

    - #### copyOf

          public static R2LightBufferDescription copyOf(R2LightBufferDescriptionType instance)

      Creates an immutable copy of a `R2LightBufferDescriptionType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
      Parameters:
        `instance` - The instance to copy
      Returns:
        A copied immutable R2LightBufferDescription instance

    - #### builder

          public static R2LightBufferDescription.Builder builder()

      Creates a builder for `R2LightBufferDescription`.
      Returns:
        A new R2LightBufferDescription builder

Copyright © 2016 <code@io7m.com> http://io7m.com